<!DOCTYPE html>
<html class="writer-html5" lang="en">
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>nl2declare.lingproc.declare_constructor &mdash; NL2Declare  documentation</title>
      <link rel="stylesheet" type="text/css" href="../../../_static/pygments.css" />
      <link rel="stylesheet" type="text/css" href="../../../_static/css/theme.css" />

  
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../" id="documentation_options" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../_static/doctools.js"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../../index.html" class="icon icon-home">
            NL2Declare
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../modules.html">nl2declare</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">NL2Declare</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../../index.html">Module code</a></li>
          <li class="breadcrumb-item"><a href="../../nl2declare.html">nl2declare</a></li>
      <li class="breadcrumb-item active">nl2declare.lingproc.declare_constructor</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for nl2declare.lingproc.declare_constructor</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">nl2declare.constructs.declare_model</span> <span class="kn">import</span> <span class="n">DeclareModel</span>
<span class="kn">from</span> <span class="nn">nl2declare.constructs.relation_type</span> <span class="kn">import</span> <span class="n">RelationType</span>
<span class="kn">from</span> <span class="nn">nl2declare.constructs.declare_constraint</span> <span class="kn">import</span> <span class="n">DeclareConstraint</span>
<span class="kn">from</span> <span class="nn">nl2declare.constructs.constraint_type</span> <span class="kn">import</span> <span class="n">ConstraintType</span>
<span class="kn">from</span> <span class="nn">nl2declare.utils.word_classes</span> <span class="kn">import</span> <span class="n">WordClasses</span>

<div class="viewcode-block" id="DeclareConstructor"><a class="viewcode-back" href="../../../nl2declare.lingproc.html#nl2declare.lingproc.declare_constructor.DeclareConstructor">[docs]</a><span class="k">class</span> <span class="nc">DeclareConstructor</span><span class="p">:</span>

<div class="viewcode-block" id="DeclareConstructor.convert_to_declare_model"><a class="viewcode-back" href="../../../nl2declare.lingproc.html#nl2declare.lingproc.declare_constructor.DeclareConstructor.convert_to_declare_model">[docs]</a>    <span class="k">def</span> <span class="nf">convert_to_declare_model</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">model</span><span class="p">):</span>
        <span class="n">declareModel</span> <span class="o">=</span> <span class="n">DeclareModel</span><span class="p">(</span><span class="n">model</span><span class="o">.</span><span class="n">text</span><span class="p">)</span>
        <span class="n">isMeta</span> <span class="o">=</span> <span class="kc">False</span>
        <span class="n">wordclasses</span> <span class="o">=</span> <span class="n">WordClasses</span><span class="p">()</span>
        <span class="k">for</span> <span class="n">rel</span> <span class="ow">in</span> <span class="n">model</span><span class="o">.</span><span class="n">interrelations</span><span class="p">:</span>
            <span class="c1">#if one action is meta (=includes a project object)</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">is_meta_action</span><span class="p">(</span><span class="n">rel</span><span class="o">.</span><span class="n">action_a</span><span class="p">)</span> <span class="ow">or</span> <span class="bp">self</span><span class="o">.</span><span class="n">is_meta_action</span><span class="p">(</span><span class="n">rel</span><span class="o">.</span><span class="n">action_b</span><span class="p">):</span>
                <span class="c1">#Unary start constraints</span>
                <span class="k">if</span> <span class="n">wordclasses</span><span class="o">.</span><span class="n">is_start_verb</span><span class="p">(</span><span class="n">rel</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">verb</span><span class="p">):</span>
                    <span class="n">ct</span> <span class="o">=</span> <span class="n">ConstraintType</span><span class="o">.</span><span class="n">INIT</span>
                    <span class="n">c</span> <span class="o">=</span> <span class="n">DeclareConstraint</span><span class="p">(</span><span class="n">ct</span><span class="p">,</span> <span class="n">rel</span><span class="o">.</span><span class="n">action_b</span><span class="p">)</span>
                    <span class="n">declareModel</span><span class="o">.</span><span class="n">constraints</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">c</span><span class="p">)</span>
                    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;FOUND:&quot;</span><span class="p">,</span> <span class="n">c</span><span class="p">)</span>
                    <span class="n">isMeta</span> <span class="o">=</span> <span class="kc">True</span>
                <span class="k">if</span> <span class="n">wordclasses</span><span class="o">.</span><span class="n">is_start_verb</span><span class="p">(</span><span class="n">rel</span><span class="o">.</span><span class="n">action_b</span><span class="o">.</span><span class="n">verb</span><span class="p">):</span>
                    <span class="n">ct</span> <span class="o">=</span> <span class="n">ConstraintType</span><span class="o">.</span><span class="n">INIT</span>
                    <span class="n">c</span> <span class="o">=</span> <span class="n">DeclareConstraint</span><span class="p">(</span><span class="n">ct</span><span class="p">,</span> <span class="n">rel</span><span class="o">.</span><span class="n">action_a</span><span class="p">)</span>
                    <span class="n">declareModel</span><span class="o">.</span><span class="n">constraints</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">c</span><span class="p">)</span>
                    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;FOUND:&quot;</span><span class="p">,</span> <span class="n">c</span><span class="p">)</span>
                    <span class="n">isMeta</span> <span class="o">=</span> <span class="kc">True</span>
                <span class="c1">#Unary end constraints</span>
                <span class="k">if</span> <span class="n">wordclasses</span><span class="o">.</span><span class="n">is_end_verb</span><span class="p">(</span><span class="n">rel</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">verb</span><span class="p">):</span>
                    <span class="n">ct</span> <span class="o">=</span> <span class="n">ConstraintType</span><span class="o">.</span><span class="n">END</span>
                    <span class="n">c</span> <span class="o">=</span> <span class="n">DeclareConstraint</span><span class="p">(</span><span class="n">ct</span><span class="p">,</span> <span class="n">rel</span><span class="o">.</span><span class="n">action_b</span><span class="p">)</span>
                    <span class="n">declareModel</span><span class="o">.</span><span class="n">constraints</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">c</span><span class="p">)</span>
                    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;FOUND:&quot;</span><span class="p">,</span> <span class="n">c</span><span class="p">)</span>
                    <span class="n">isMeta</span> <span class="o">=</span> <span class="kc">True</span>
                <span class="k">if</span> <span class="n">wordclasses</span><span class="o">.</span><span class="n">is_end_verb</span><span class="p">(</span><span class="n">rel</span><span class="o">.</span><span class="n">action_b</span><span class="o">.</span><span class="n">verb</span><span class="p">):</span>
                    <span class="n">ct</span> <span class="o">=</span> <span class="n">ConstraintType</span><span class="o">.</span><span class="n">END</span>
                    <span class="n">c</span> <span class="o">=</span> <span class="n">DeclareConstraint</span><span class="p">(</span><span class="n">ct</span><span class="p">,</span> <span class="n">rel</span><span class="o">.</span><span class="n">action_a</span><span class="p">)</span>
                    <span class="n">declareModel</span><span class="o">.</span><span class="n">constraints</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">c</span><span class="p">)</span>
                    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;FOUND:&quot;</span><span class="p">,</span> <span class="n">c</span><span class="p">)</span>
                    <span class="n">isMeta</span> <span class="o">=</span> <span class="kc">True</span>

            <span class="k">if</span> <span class="n">isMeta</span><span class="o">==</span><span class="kc">False</span> <span class="ow">and</span> <span class="n">rel</span><span class="o">.</span><span class="n">type</span> <span class="o">==</span> <span class="n">RelationType</span><span class="o">.</span><span class="n">FOLLOWS</span><span class="p">:</span>
                <span class="n">ct</span> <span class="o">=</span> <span class="kc">None</span>
                <span class="n">aMand</span> <span class="o">=</span> <span class="n">wordclasses</span><span class="o">.</span><span class="n">is_mandatory</span><span class="p">(</span><span class="n">rel</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">modal</span><span class="p">)</span>
                <span class="n">bMand</span> <span class="o">=</span> <span class="n">wordclasses</span><span class="o">.</span><span class="n">is_mandatory</span><span class="p">(</span><span class="n">rel</span><span class="o">.</span><span class="n">action_b</span><span class="o">.</span><span class="n">modal</span><span class="p">)</span>

                <span class="k">if</span> <span class="n">bMand</span> <span class="o">==</span> <span class="kc">False</span><span class="p">:</span>
                    <span class="n">ct</span> <span class="o">=</span> <span class="n">ConstraintType</span><span class="o">.</span><span class="n">PRECEDENCE</span>
                <span class="k">if</span> <span class="n">aMand</span> <span class="ow">and</span> <span class="n">bMand</span><span class="p">:</span>
                    <span class="n">ct</span> <span class="o">=</span> <span class="n">ConstraintType</span><span class="o">.</span><span class="n">SUCCESSION</span>
                <span class="k">if</span> <span class="n">bMand</span> <span class="ow">and</span> <span class="n">aMand</span> <span class="o">==</span> <span class="kc">False</span><span class="p">:</span>
                    <span class="n">ct</span> <span class="o">=</span> <span class="n">ConstraintType</span><span class="o">.</span><span class="n">RESPONSE</span>

                <span class="n">c</span> <span class="o">=</span> <span class="n">DeclareConstraint</span><span class="p">(</span><span class="n">ct</span><span class="p">,</span><span class="n">rel</span><span class="o">.</span><span class="n">action_a</span><span class="p">,</span> <span class="n">rel</span><span class="o">.</span><span class="n">action_b</span><span class="p">)</span>
                <span class="k">if</span> <span class="n">c</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">is_negative</span> <span class="ow">or</span> <span class="n">c</span><span class="o">.</span><span class="n">action_b</span><span class="o">.</span><span class="n">is_negative</span><span class="p">:</span>
                    <span class="n">c</span><span class="o">.</span><span class="n">is_negative</span> <span class="o">=</span> <span class="kc">True</span>
                <span class="n">declareModel</span><span class="o">.</span><span class="n">constraints</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">c</span><span class="p">)</span>
        
        <span class="k">return</span> <span class="n">declareModel</span></div>
        

<div class="viewcode-block" id="DeclareConstructor.is_meta_action"><a class="viewcode-back" href="../../../nl2declare.lingproc.html#nl2declare.lingproc.declare_constructor.DeclareConstructor.is_meta_action">[docs]</a>    <span class="k">def</span> <span class="nf">is_meta_action</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">action</span><span class="p">):</span>
        <span class="n">joint</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
        <span class="k">if</span><span class="p">(</span><span class="n">action</span><span class="o">.</span><span class="n">object</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span> <span class="n">action</span><span class="o">.</span><span class="n">subject</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">):</span>
            <span class="n">joint</span> <span class="o">=</span> <span class="n">action</span><span class="o">.</span><span class="n">object</span><span class="o">.</span><span class="n">text</span> <span class="o">+</span> <span class="s2">&quot; &quot;</span> <span class="o">+</span> <span class="n">action</span><span class="o">.</span><span class="n">subject</span><span class="o">.</span><span class="n">text</span>
        <span class="k">elif</span><span class="p">(</span><span class="n">action</span><span class="o">.</span><span class="n">object</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">):</span>
            <span class="n">joint</span> <span class="o">=</span> <span class="n">action</span><span class="o">.</span><span class="n">object</span><span class="o">.</span><span class="n">text</span>
        <span class="k">elif</span><span class="p">(</span><span class="n">action</span><span class="o">.</span><span class="n">subject</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">):</span>
            <span class="n">joint</span> <span class="o">=</span> <span class="n">action</span><span class="o">.</span><span class="n">subject</span><span class="o">.</span><span class="n">text</span>

        <span class="n">wordclasses</span> <span class="o">=</span> <span class="n">WordClasses</span><span class="p">()</span>

        <span class="k">for</span> <span class="n">processObject</span> <span class="ow">in</span> <span class="n">wordclasses</span><span class="o">.</span><span class="n">PROCESS_OBJECTS</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">processObject</span> <span class="ow">in</span> <span class="n">joint</span><span class="p">:</span>
                <span class="k">return</span> <span class="kc">True</span>

        <span class="k">return</span> <span class="kc">False</span></div></div>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2024, Pia Halkour, Marc Ludevid Wulf, Julian Kofferath.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>